Subject: [Ltru] Re: HTAB (was: draft-ietf-ltru-4646bis-05)

From: "Doug Ewell" <[email-masked]>
Date: Sat, 12 May 2007 11:59:37 -0700

Frank Ellermann <nobody at xyzzy dot claranet dot de> wrote:

> The old syntax used LWSP:
>   field-body = *(ASCCHAR/LWSP)
>
> LWSP is defined in RFC 4234:
>   LWSP       = *(WSP / CRLF WSP)
>
> The -06 syntax uses WSP:
>   field-body = *(([*WSP CRLF] 1*WSP) 1*ASCCHAR)
>
> WSP is defined in RFC 4234:
>    WSP       = SP / HTAB
>
> Even if there is no HT in the registry at the moment all tools doing
> something with it are supposed to handle tab characters as white 
> space.

Now I know I'm missing something.  If LWSP is defined in terms of WSP, 
which is defined in terms of HTAB, then where does the -06 syntax 
introduce a problem with HTAB that doesn't already exist?

--
Doug Ewell  *  Fullerton, California, USA  *  RFC 4645  *  UTN #14
http://users.adelphia.net/~dewell/
http://www1.ietf.org/html.charters/ltru-charter.html
http://www.alvestrand.no/mailman/listinfo/ietf-languages

_______________________________________________
Ltru mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/ltru

---

From: "Doug Ewell" <[email-masked]>
Date: Sat, 12 May 2007 12:14:58 -0700

Frank Ellermann <[email-masked]>

>> I observe again that IANA is distributing the Registry with 
>> LF-terminated lines, even though RFC 4646 Section 3.1 specifies CRLF
>
> Cheat:     [[Kids, don't try this on a Mac, *NIX, or Linux box]]
> <ftp://ftp.iana.org/assignments/language-subtag-registry;type=a>

I don't have any difficulty converting any combination of CR, LF, NEL, 
LS, PS to any other.  But IANA doesn't publish a link to the FTP 
resource, only to the HTTP resource.

---

From: Frank Ellermann <[email-masked]>
Date: Sat, 12 May 2007 21:35:56 +0200

Doug Ewell wrote:

> where does the -06 syntax introduce a problem with HTAB that 
> doesn't already exist?

It doesn't, we could only decide to get rid of it, replacing
WSP by SP.  

A (maybe unintentional) new feature of the -06 syntax is that
at least one WSP after the colon is required.  At the moment
(4646) you could write "comment:some text", with -06 it has 
to be "comment: some text" (examples).  Intentional or not, I
like that new feature.

Frank

---

From: Addison Phillips <[email-masked]>
Date: Mon, 14 May 2007 14:03:25 -0700

Having dinked with it some more, I'd like to propose this version of 
this ABNF:

--
registry   = record *("%%" CRLF record)
record     = 1*( field-name *SP ":" *SP field-body CRLF )
field-name = (ALPHA / DIGIT) [*(ALPHA / DIGIT / "-") (ALPHA / DIGIT)]
field-body = *([[*SP CRLF] 1*SP] 1*ASCCHAR)
ASCCHAR    = %x21-25 ; ASCII printable characters
            / %x27-7E ; AMPERSAND is %x26
            / UNICHAR
UNICHAR    = "&amp;#x" 2*6HEXDIG ";"
--

Note that I make the production equivalent to FWS optional. I also 
reformatted ASCCHAR for legibility, adding the note about ASCII 
printables. And, yes, I disallow HTAB. I don't see that this should 
cause a ruckus.

Any comments?

Addison

-- 
Addison Phillips
Globalization Architect -- Yahoo! Inc.

Internationalization is an architecture.
It is not a feature.

---

From: Frank Ellermann <[email-masked]>
Date: Tue, 15 May 2007 22:32:02 +0200

> registry   = record *("%%" CRLF record)

+1 (no change)

> record     = 1*( field-name *SP ":" *SP field-body CRLF )

You could remove the second *SP now, but keeping it is okay.

> field-name = (ALPHA / DIGIT) [*(ALPHA / DIGIT / "-") (ALPHA / DIGIT)]

+1 (no change)

> field-body = *([[*SP CRLF] 1*SP] 1*ASCCHAR)

+1 (no more mandatory SP after the colon as in -06)

>             / %x27-7E ; AMPERSAND is %x26

The old one-liner was IMO clearer.

> UNICHAR    = "&amp;#x" 2*6HEXDIG ";"

That's still wrong, a 4646 bug, a fixed version was published in
<http://tools.ietf.org/id/draft-klensin-unicode-escapes-03.txt>

| EmbeddedUnicodeChar =   %x26.23.78 2*6HEXDIG ";" ; starts with "&#x"

The issue isn't the &amp; - that's only a side-effect of posting
the raw XML input.  The issue is the "x" under 4234 or 4234bis
rules, it implicitly means "'x' or 'X'" (compare <privateuse>).

A hex. XML NCR can't be &#X102345; with an upper case 'X', it
has to be &#x102345; with a lower case 'x'.  Putting it together
I arrive at:

| ASCCHAR    = %x21-25 / %x27-7E / UNICHAR ; Note: AMPERSAND is %x26
| UNICHAR    = %x26.23.78 2*6HEXDIG ";"    ; starts with "&#x"

Frank

---

From: John Cowan <[email-masked]>
Date: Wed, 16 May 2007 00:44:15 -0400

> rules, it implicitly means "'x' or 'X'" (compare <privateuse>).

Why is that a bug?  It seems to me that the same rules that apply
to XML hex character references should apply: namely, x or X
before the hex digits, which themselves can be 0-9, a-f, or A-F.

-- 
It was impossible to inveigle           John Cowan <[email-masked]>
Georg Wilhelm Friedrich Hegel           http://www.ccil.org/~cowan
Into offering the slightest apology
For his Phenomenology.                      --W. H. Auden, from "People" (1953)

---

From: Martin Duerst <[email-masked]>
Date: Wed, 16 May 2007 15:39:48 +0900

>before the hex digits, which themselves can be 0-9, a-f, or A-F.

Because XML Numeric Character References do NOT allow uppercase 'X'.
Please check the spec if you don't believe it.

[If you want to know why, I guess the best person to ask is Tim Bray.]

Regards,   Martin.

#-#-#  Martin J. Du"rst, Assoc. Professor, Aoyama Gakuin University
#-#-#  http://www.sw.it.aoyama.ac.jp       mailto:[email-masked]

---

From: John Cowan <[email-masked]>
Date: Wed, 16 May 2007 12:31:42 -0400

> Because XML Numeric Character References do NOT allow uppercase 'X'.

My bad.  You're right.  Our use of 'x' is a bug and should be fixed.

-- 
Newbies always ask:                             John Cowan
  "Elements or attributes?                      http://www.ccil.org/~cowan
Which will serve me best?"                      [email-masked]
  Those who know roar like lions;
  Wise hackers smile like tigers.                   --a tanka, or extended haiku